/*
 * Copyright (c) 2012, Freescale Semiconductor, Inc.
 * All rights reserved.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

// File: uart_iomux_config.c

/* ------------------------------------------------------------------------------
 * <auto-generated>
 *     This code was generated by a tool.
 *     Runtime Version:3.4.0.0
 *
 *     Changes to this file may cause incorrect behavior and will be lost if
 *     the code is regenerated.
 * </auto-generated>
 * ------------------------------------------------------------------------------
*/

#include "iomux_config.h"
#include "registers/regsiomuxc.h"
#include "registers/regsuart.h"
#include "io.h"
#include <assert.h>

static void uart1_iomux_config(void) {
    HW_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_WR(
                BF_IOMUXC_UART1_UART_RX_DATA_SELECT_INPUT_DAISY_V(CSI0_DATA11_ALT3));

    HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA11_WR(0x00000003);
    HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA11_WR(0x0001b0b1);
    HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA10_WR(0x00000003);
    HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA10_WR(0x0001b0b1);
}

static void uart2_iomux_config(void) {
    HW_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_WR(
            BF_IOMUXC_UART2_UART_RX_DATA_SELECT_INPUT_DAISY_V(EIM_DATA27_ALT4));
    HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA26_WR(0x00000004);
    HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA26_WR(0x0001b0b1);
    HW_IOMUXC_SW_MUX_CTL_PAD_EIM_DATA27_WR(0x00000004);
    HW_IOMUXC_SW_PAD_CTL_PAD_EIM_DATA27_WR(0x0001b0b1);
}

static void uart3_iomux_config(void) {
    /* не выведен */
}

static void uart4_iomux_config(void) {
    HW_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_WR(
                BF_IOMUXC_UART4_UART_RX_DATA_SELECT_INPUT_DAISY_V(CSI0_DATA13_ALT3));

    HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA12_WR(0x00000003);
    HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA12_WR(0x0001b0b1);
    HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA13_WR(0x00000003);
    HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA13_WR(0x0001b0b1);
}

static void uart5_iomux_config(void) {
    HW_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_WR(
                BF_IOMUXC_UART5_UART_RX_DATA_SELECT_INPUT_DAISY_V(CSI0_DATA15_ALT3));


    HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA14_WR(0x00000003);
    HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA14_WR(0x0001b0b1);
    HW_IOMUXC_SW_MUX_CTL_PAD_CSI0_DATA15_WR(0x00000003);
    HW_IOMUXC_SW_PAD_CTL_PAD_CSI0_DATA15_WR(0x0001b0b1);
}


void uart_iomux_config(int instance) {
    switch (instance) {
        case HW_UART1:
            return uart1_iomux_config();
        case HW_UART2:
            return uart2_iomux_config();
        case HW_UART3:
            return uart3_iomux_config();
        case HW_UART4:
            return uart4_iomux_config();
        case HW_UART5:
            return uart5_iomux_config();
        default:
            assert(0);
    }
}


